# remirepo/Fedora spec file for php-zendframework-zend-test
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    626606425072e9d513df3bf723913c0bb9d03f8c
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-test
%global php_home     %{_datadir}/php
%global library      Test
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        3.2.0
Release:        2%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-composer(phpunit/phpunit)                   >= 4.0
BuildRequires:  phpunit6
BuildRequires:  phpunit7
BuildRequires:  php-pcre
BuildRequires:  php-autoloader(%{gh_owner}/zend-console)        >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-dom)            >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2
BuildRequires:  php-autoloader(%{gh_owner}/zend-http)           >= 2.5.4
BuildRequires:  php-autoloader(%{gh_owner}/zend-mvc)            >= 3.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
BuildRequires:  php-autoloader(%{gh_owner}/zend-uri)            >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-view)           >= 2.6.3
# From composer, "require-dev": {
#        "mikey179/vfsStream": "~1.2",
#        "symfony/finder": "^2.2",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-i18n": "^2.6",
#        "zendframework/zend-log": "^2.7.1",
#        "zendframework/zend-modulemanager": "^2.7.1",
#        "zendframework/zend-mvc-console": "^1.1.8",
#        "zendframework/zend-mvc-plugin-flashmessenger": "^0.1.0",
#        "zendframework/zend-serializer": "^2.6.1",
#        "zendframework/zend-session": "^2.8.5",
#        "zendframework/zend-validator": "^2.8"
BuildRequires:  php-composer(mikey179/vfsStream)                >= 1.2
BuildRequires:  php-symfony-finder
BuildRequires:  php-autoloader(%{gh_owner}/zend-i18n)           >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-log)            >= 2.7.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-modulemanager)  >= 2.7.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-mvc-console)    >= 1.1.8
BuildRequires:  php-autoloader(%{gh_owner}/zend-mvc-plugin-flashmessenger) >= 0.1.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-serializer)     >= 2.6.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)        >= 2.8.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      >= 2.8
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "phpunit/phpunit": "^4.0 || ^5.0 || ^6.0 || ^7.0",
#        "sebastian/version": "^1.0.4 || ^2.0",
#        "zendframework/zend-console": "^2.6",
#        "zendframework/zend-dom": "^2.6",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-http": "^2.5.4",
#        "zendframework/zend-mvc": "^2.7.1",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0",
#        "zendframework/zend-uri": "^2.5",
#        "zendframework/zend-view": "^2.6.3"
Requires:       php(language) >= 5.6
Recommends:     phpunit7
Recommends:     phpunit6
Recommends:     php-composer(phpunit/phpunit)                   >= 4.0
Requires:       php-composer(sebastian/version)                 >= 1.0.4
Requires:       php-composer(sebastian/version)                 <  3
%if ! %{bootstrap}
Requires:       php-autoloader(%{gh_owner}/zend-console)        >= 2.6
Requires:       php-autoloader(%{gh_owner}/zend-console)        <  3
Requires:       php-autoloader(%{gh_owner}/zend-dom)            >= 2.6
Requires:       php-autoloader(%{gh_owner}/zend-dom)            <  3
Requires:       php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2
Requires:       php-autoloader(%{gh_owner}/zend-eventmanager)   <  4
Requires:       php-autoloader(%{gh_owner}/zend-http)           >= 2.5.4
Requires:       php-autoloader(%{gh_owner}/zend-http)           <  3
Requires:       php-autoloader(%{gh_owner}/zend-mvc)            >= 3.0
Requires:       php-autoloader(%{gh_owner}/zend-mvc)            <  4
Requires:       php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5
Requires:       php-autoloader(%{gh_owner}/zend-servicemanager) <  4
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:       php-autoloader(%{gh_owner}/zend-uri)            >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-uri)            <  3
Requires:       php-autoloader(%{gh_owner}/zend-view)           >= 2.6.3
Requires:       php-autoloader(%{gh_owner}/zend-view)           <  3
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.1
Requires:       php-pcre

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\Test component provides tools to facilitate unit testing of your
Zend Framework applications. At this time, we offer facilities to enable
testing of your Zend Framework MVC applications.

PHPUnit is the only library supported currently.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create dependency autoloader - deprecated
mv autoload/*.php src

cat << 'EOF' | tee autoload.php
<?php
require_once __DIR__ . '/%{library}/phpunit-class-aliases.php';
EOF

: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    __DIR__ . '/phpunit-class-aliases.php',
    '%{php_home}/Zend/Console/autoload.php',
    '%{php_home}/Zend/Dom/autoload.php',
    '%{php_home}/Zend/EventManager/autoload.php',
    '%{php_home}/Zend/Http/autoload.php',
    '%{php_home}/Zend/Mvc/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Uri/autoload.php',
    '%{php_home}/Zend/View/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/org/bovigo/vfs/autoload.php',
    '%{php_home}/Symfony/Component/Finder/autoload.php',
    '%{php_home}/Zend/I18n/autoload.php',
    '%{php_home}/Zend/Log/autoload.php',
    '%{php_home}/Zend/ModuleManager/autoload.php',
    '%{php_home}/Zend/Serializer/autoload.php',
    '%{php_home}/Zend/Mvc/Console/autoload.php',
    '%{php_home}/Zend/Mvc/Plugin/FlashMessenger/autoload.php',
    '%{php_home}/Zend/Serializer/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php70 php71 php72; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit --verbose || ret=1
  fi
done
if [ -f %{_bindir}/phpunit6 ]; then
  for cmd in php php70 php71 php72; do
    if which $cmd; then
      $cmd %{_bindir}/phpunit6 --verbose || ret=1
    fi
  done
fi
if [ -f %{_bindir}/phpunit7 ]; then
  for cmd in php php71 php72; do
    if which $cmd; then
      $cmd %{_bindir}/phpunit7 --verbose || ret=1
    fi
  done
fi
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}
%{php_home}/Zend/%{library}-autoload.php


%changelog
* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Apr 12 2018 Remi Collet <remi@remirepo.net> - 3.2.0-1
- update to 3.2.0
- allow phpunit7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Dec 13 2017 Remi Collet <remi@remirepo.net> - 3.1.1-2
- switch from zend-loader to fedora/autoloader

* Mon Oct 30 2017 Remi Collet <remi@remirepo.net> - 3.1.1-1
- Update to 3.1.1
- add autoloader for class aliases

* Sun Oct 29 2017 Remi Collet <remi@remirepo.net> - 3.1.0-3
- fix FTBFS from Koschei, add fix for recent PHPUnit from
  https://github.com/zendframework/zend-test/pull/55

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue May  2 2017 Remi Collet <remi@remirepo.net> - 3.1.0-1
- Update to 3.1.0
- run test suite against phpunit v5 and v6
- make dependency in phpunit optional (v5 or v6)

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Sep  7 2016 Remi Collet <remi@fedoraproject.org> - 3.0.2-1
- update to 3.0.2 for ZendFramework 3
- raise dependency on PHP 5.6
- raise dependency on zend-mvc >= 3.0

* Mon Apr 18 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-2
- allow sebastian/version 2.0

* Thu Mar  3 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1
- raise dependency on zend-mvc >= 2.7.1
- raise dependency on zend-console >= 2.6
- raise dependency on zend-dom >= 2.6
- raise dependency on zend-eventmanager >= 2.6.2
- raise dependency on zend-http >= 2.5.4
- raise dependency on zend-servicemanager >= 2.7.5
- raise dependency on zend-stdlib >= 2.7
- raise dependency on zend-view >= 2.6.3
- add dependency on sebastian/version

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Dec  9 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise dependency on PHP >= 5.5
- allow PHPUnit 5

* Fri Oct  2 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-2
- ignore phpunit upstream recommended max version

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
